Debian Bug report logs - #430121
xterm: EOL characters missing from selection (affects triple-click)

version graph

Package: xterm; Maintainer for xterm is Debian X Strike Force <debian-x@lists.debian.org>; Source for xterm is src:xterm.

Reported by: Vincent Lefevre <vincent@vinc17.org>

Date: Fri, 22 Jun 2007 14:00:02 UTC

Severity: normal

Found in version xterm/226-1

Fixed in version xterm/228-1

Done: Julien Cristau <jcristau@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
New Bug report received and forwarded. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: xterm: EOL characters missing from selection (affects triple-click)
Date: Fri, 22 Jun 2007 15:58:17 +0200
[Message part 1 (text/plain, inline)]
Package: xterm
Version: 226-1
Severity: normal

EOL characters are sometimes missing from the selection. This affects
the triple-click, which selects too much in such a case.

I've attached a snapshot. If I triple-click on the line

  make[1]: *** [all-recursive] Error 1

or below, the whole part from this line to the bottom is selected.
Ditto concerning the 3 lines above the mentioned line.

I thought the problem could come from spaces at the end of some lines,
but I could see with a normal selection (single-click + drag) that
these lines contain no trailing spaces.

I've attached the selection of what is displayed on the snapshot.
You can see that some EOL characters are missing.

I've also attached the output of "appres XTerm".

-- System Information:
Debian Release: lenny/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable')
Architecture: i386 (i686)

Kernel: Linux 2.6.18-4-686-bigmem (SMP w/2 CPU cores)
Locale: LANG=POSIX, LC_CTYPE=en_US.ISO8859-1 (charmap=ISO-8859-1)
Shell: /bin/sh linked to /bin/bash

Versions of packages xterm depends on:
ii  libc6                         2.5-11     GNU C Library: Shared libraries
ii  libfontconfig1                2.4.2-1.2  generic font configuration library
ii  libice6                       1:1.0.3-2  X11 Inter-Client Exchange library
ii  libncurses5                   5.6-3      Shared libraries for terminal hand
ii  libsm6                        2:1.0.3-1  X11 Session Management library
ii  libx11-6                      2:1.0.3-7  X11 client-side library
ii  libxaw7                       1:1.0.3-3  X11 Athena Widget library
ii  libxext6                      1:1.0.3-2  X11 miscellaneous extension librar
ii  libxft2                       2.1.12-2   FreeType-based font drawing librar
ii  libxmu6                       1:1.0.3-1  X11 miscellaneous utility library
ii  libxt6                        1:1.0.5-3  X11 toolkit intrinsics library
ii  xbitmaps                      1.0.1-2    Base X bitmaps

Versions of packages xterm recommends:
ii  xutils                      1:7.1.ds.3-1 X Window System utility programs

-- no debconf information
[xterm-tripleclick.png (image/png, attachment)]
[clipboard (text/plain, attachment)]
[appres-XTerm (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #10 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: 430121@bugs.debian.org
Subject: Re: xterm: EOL characters missing from selection (affects triple-click)
Date: Fri, 22 Jun 2007 16:28:06 +0200
On 2007-06-22 15:58:17 +0200, Vincent Lefevre wrote:
> Package: xterm
> Version: 226-1
> Severity: normal
> 
> EOL characters are sometimes missing from the selection. This affects
> the triple-click, which selects too much in such a case.
[...]

This was even worse: when I selected other parts of the xterm buffer,
the primary selection wasn't changed: middle-clicking to another place
pasted an older selection.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #15 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: 430121@bugs.debian.org
Subject: Re: xterm: EOL characters missing from selection (affects triple-click)
Date: Fri, 22 Jun 2007 16:40:40 +0200
On 2007-06-22 15:58:17 +0200, Vincent Lefevre wrote:
> Package: xterm
> Version: 226-1
> Severity: normal
> 
> EOL characters are sometimes missing from the selection. This affects
> the triple-click, which selects too much in such a case.
[...]

I could reproduce the EOL problem in other two xterm windows. While
lots of data were output (e.g. running "make"), I scrolled upward
with the mouse and tried to do some selections. Triple-clicks didn't
work correctly even after the output stopped.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #20 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Sat, 23 Jun 2007 12:00:33 -0400
[Message part 1 (text/plain, inline)]
On Fri, Jun 22, 2007 at 04:50:10PM +0200, Vincent Lefevre wrote:
> On 2007-06-22 15:58:17 +0200, Vincent Lefevre wrote:
> > Package: xterm
> > Version: 226-1
> > Severity: normal
> >
> > EOL characters are sometimes missing from the selection. This affects
> > the triple-click, which selects too much in such a case.

perhaps you are using "screen"

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #25 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Mon, 25 Jun 2007 14:41:06 +0200
On 2007-06-23 18:20:09 +0200, Thomas Dickey wrote:
> perhaps you are using "screen"

No, I wasn't using screen. BTW, I thought the problem could be
related to colors, but I could reproduce it without colors.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #30 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: Thomas Dickey <dickey@radix.net>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Mon, 25 Jun 2007 08:56:34 -0400
[Message part 1 (text/plain, inline)]
On Mon, Jun 25, 2007 at 02:41:06PM +0200, Vincent Lefevre wrote:
> On 2007-06-23 18:20:09 +0200, Thomas Dickey wrote:
> > perhaps you are using "screen"
> 
> No, I wasn't using screen. BTW, I thought the problem could be
> related to colors, but I could reproduce it without colors.

In a quick check I was not able to see the problem.

xterm marks wrapped lines as it sees text being written across the right
margin, and those marks tell it how long a line really is.  Clearing the
screen is supposed to remove the marks, scrolling shifts-in unmarked
lines, etc.  I haven't made any recent changes that I would suspect
alter that behavior (though ongoing unrelated fixes can break things).

So I wanted to check first if you were using screen, since (although it
usually is not a problem), it is not guaranteed to write text
top-to-bottom like a dumb terminal.

From the information I have, it's not unlikely that the behavior could
be reproduced by replaying a typescript from 'script'.  Is it possible
that you could provide a typescript for a session where the bug appears?
The screenshot doesn't tell me how xterm got into the state that's
showing the problem.

thanks

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #35 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Mon, 25 Jun 2007 15:17:50 +0200
On 2007-06-25 08:56:34 -0400, Thomas Dickey wrote:
> xterm marks wrapped lines as it sees text being written across the right
> margin, and those marks tell it how long a line really is.  Clearing the
> screen is supposed to remove the marks, scrolling shifts-in unmarked
> lines, etc.  I haven't made any recent changes that I would suspect
> alter that behavior (though ongoing unrelated fixes can break things).

I haven't tried with older versions, but the bug may be old.

> From the information I have, it's not unlikely that the behavior could
> be reproduced by replaying a typescript from 'script'.  Is it possible
> that you could provide a typescript for a session where the bug appears?

Would ttyrec be OK? I only have my laptop here and "script" isn't
installed.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #40 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Mon, 25 Jun 2007 09:21:26 -0400
[Message part 1 (text/plain, inline)]
On Mon, Jun 25, 2007 at 03:17:50PM +0200, Vincent Lefevre wrote:
> On 2007-06-25 08:56:34 -0400, Thomas Dickey wrote:
> > xterm marks wrapped lines as it sees text being written across the right
> > margin, and those marks tell it how long a line really is.  Clearing the
> > screen is supposed to remove the marks, scrolling shifts-in unmarked
> > lines, etc.  I haven't made any recent changes that I would suspect
> > alter that behavior (though ongoing unrelated fixes can break things).
> 
> I haven't tried with older versions, but the bug may be old.

that happens...
 
> > From the information I have, it's not unlikely that the behavior could
> > be reproduced by replaying a typescript from 'script'.  Is it possible
> > that you could provide a typescript for a session where the bug appears?
> 
> Would ttyrec be OK? I only have my laptop here and "script" isn't
> installed.

That sounds ok (google suggests it's a form of 'script').

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #45 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Tue, 26 Jun 2007 09:27:29 +0200
[Message part 1 (text/plain, inline)]
On 2007-06-25 09:21:26 -0400, Thomas Dickey wrote:
> On Mon, Jun 25, 2007 at 03:17:50PM +0200, Vincent Lefevre wrote:
> > Would ttyrec be OK? I only have my laptop here and "script" isn't
> > installed.
> 
> That sounds ok (google suggests it's a form of 'script').

Unfortunately, ttyrec no longer works on my PowerBook (I get the
error "Out of pty's"). But I've tried xterm's "log to file" feature.
This log file (attached) looks OK, though I could reproduce the bug.
For instance, in the selection, there was no newline after the line
ending with ".libs/uceil_log2.o", but it is present in the log file.

I recall the basic step to reproduce the bug:
1. Run a program that generates very long lines, such as make on MPFR
   (and wait a bit to have sufficient data in the terminal).
2. Move back in the Xterm scrollback buffer.
3. Triple-click, and let the mouse button pressed (in particular on a
   slow machine).

Xterm soon gets lost in the selection. While the mouse button is still
pressed, move the mouse pointer upward and downward: one can already
see that the paragraph limits do not correspond to the real newline
characters.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)
[Xterm.log (text/plain, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #50 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: Thomas Dickey <dickey@radix.net>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Tue, 26 Jun 2007 06:03:21 -0400
[Message part 1 (text/plain, inline)]
On Tue, Jun 26, 2007 at 09:27:29AM +0200, Vincent Lefevre wrote:
> On 2007-06-25 09:21:26 -0400, Thomas Dickey wrote:
> > On Mon, Jun 25, 2007 at 03:17:50PM +0200, Vincent Lefevre wrote:
> > > Would ttyrec be OK? I only have my laptop here and "script" isn't
> > > installed.
> > 
> > That sounds ok (google suggests it's a form of 'script').
> 
> Unfortunately, ttyrec no longer works on my PowerBook (I get the
> error "Out of pty's"). But I've tried xterm's "log to file" feature.
> This log file (attached) looks OK, though I could reproduce the bug.
> For instance, in the selection, there was no newline after the line
> ending with ".libs/uceil_log2.o", but it is present in the log file.

I'll see if I can make that replay (it "should" work)
 
> I recall the basic step to reproduce the bug:
> 1. Run a program that generates very long lines, such as make on MPFR
>    (and wait a bit to have sufficient data in the terminal).

I'll look into that.  For my quick check, I did an "ls -l /usr/bin",
and clicked on the singly-wrapped lines showing symbolic links.
(I also tried it with your environment settings ;-)

Your picture shows you're using a color-make (will try that).
I did notice the clock in the prompt - makes me wonder if it is writing
out to the margin and in some way confusing the xterm.  Is that a separate
program, or part of bash?

thanks

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #55 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Tue, 26 Jun 2007 14:58:31 +0200
On 2007-06-26 06:03:21 -0400, Thomas Dickey wrote:
> On Tue, Jun 26, 2007 at 09:27:29AM +0200, Vincent Lefevre wrote:
> > Unfortunately, ttyrec no longer works on my PowerBook (I get the
> > error "Out of pty's"). But I've tried xterm's "log to file" feature.
> > This log file (attached) looks OK, though I could reproduce the bug.
> > For instance, in the selection, there was no newline after the line
> > ending with ".libs/uceil_log2.o", but it is present in the log file.
> 
> I'll see if I can make that replay (it "should" work)

A naive replay won't work: you need (triple-)clicks while the output
occurs to be able to reproduce the bug (such clicks more or less
freeze xterm's output).

> > I recall the basic step to reproduce the bug:
> > 1. Run a program that generates very long lines, such as make on MPFR
> >    (and wait a bit to have sufficient data in the terminal).
> 
> I'll look into that.  For my quick check, I did an "ls -l /usr/bin",
> and clicked on the singly-wrapped lines showing symbolic links.
> (I also tried it with your environment settings ;-)

FYI, I couldn't reproduce the problem with ls -lR.

> Your picture shows you're using a color-make (will try that).

Color doesn't make any difference (see Xterm.log that was attached,
this example had no colors).

> I did notice the clock in the prompt - makes me wonder if it is writing
> out to the margin and in some way confusing the xterm.  Is that a separate
> program, or part of bash?

It is part of zsh, but shouldn't have any influcence. IMHO, that's
the clicks that confuse xterm.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #60 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Tue, 26 Jun 2007 09:24:44 -0400
[Message part 1 (text/plain, inline)]
On Tue, Jun 26, 2007 at 02:58:31PM +0200, Vincent Lefevre wrote:
> On 2007-06-26 06:03:21 -0400, Thomas Dickey wrote:
> > I'll see if I can make that replay (it "should" work)
> 
> A naive replay won't work: you need (triple-)clicks while the output
> occurs to be able to reproduce the bug (such clicks more or less
> freeze xterm's output).

I would take that into account.  The main thing that a reply would
do would be to set the screen up as it was when you clicked on it,
e.g., erasures, wrapping-marks, etc.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #65 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Tue, 26 Jun 2007 15:31:32 +0200
On 2007-06-26 09:24:44 -0400, Thomas Dickey wrote:
> On Tue, Jun 26, 2007 at 02:58:31PM +0200, Vincent Lefevre wrote:
> > A naive replay won't work: you need (triple-)clicks while the output
> > occurs to be able to reproduce the bug (such clicks more or less
> > freeze xterm's output).
> 
> I would take that into account.  The main thing that a reply would
> do would be to set the screen up as it was when you clicked on it,
> e.g., erasures, wrapping-marks, etc.

But clicks are not logged, so it would not be the same state (clicks
shouldn't affect the buffer state, but the present bug is that they
seem to affect this state).

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #70 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Tue, 26 Jun 2007 19:32:22 -0400
[Message part 1 (text/plain, inline)]
On Tue, Jun 26, 2007 at 03:31:32PM +0200, Vincent Lefevre wrote:
> On 2007-06-26 09:24:44 -0400, Thomas Dickey wrote:
> > On Tue, Jun 26, 2007 at 02:58:31PM +0200, Vincent Lefevre wrote:
> > > A naive replay won't work: you need (triple-)clicks while the output
> > > occurs to be able to reproduce the bug (such clicks more or less
> > > freeze xterm's output).
> > 
> > I would take that into account.  The main thing that a reply would
> > do would be to set the screen up as it was when you clicked on it,
> > e.g., erasures, wrapping-marks, etc.
> 
> But clicks are not logged, so it would not be the same state (clicks
> shouldn't affect the buffer state, but the present bug is that they
> seem to affect this state).

hmm.  Going back through the thread, it seems you're talking about selecting
text while it's moving.

All I'm able to see is a case that I can explain: if the text doesn't
move, and I happen to be clicking near the place where two different lines
are displayed, I can get a selection-extension at the same time that I'm
(nominally) doing a triple click.  Slowly cat'ing the text in a loop gives
the same effect - occasionally the clicking results in a selection-extension.

Outside of that - I'm not seeing any instance where it selects past the
current line.  From your report, I cannot tell if there's a particular
place on the screen where problem occurs.  For instance, selecting near
the bottom, or close to one side might be relevant.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #75 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 08:48:01 +0200
On 2007-06-26 19:32:22 -0400, Thomas Dickey wrote:
> hmm.  Going back through the thread, it seems you're talking about selecting
> text while it's moving.

Yes.

> Outside of that - I'm not seeing any instance where it selects past the
> current line.  From your report, I cannot tell if there's a particular
> place on the screen where problem occurs.  For instance, selecting near
> the bottom, or close to one side might be relevant.

I was triple-clicking near the center of the window. But perhaps you
should let the mouse button pressed longer and move the mouse pointer
upward/downward.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #80 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 06:06:56 -0400
[Message part 1 (text/plain, inline)]
On Wed, Jun 27, 2007 at 08:48:01AM +0200, Vincent Lefevre wrote:
> On 2007-06-26 19:32:22 -0400, Thomas Dickey wrote:
> > hmm.  Going back through the thread, it seems you're talking about selecting
> > text while it's moving.
> 
> Yes.
> 
> > Outside of that - I'm not seeing any instance where it selects past the
> > current line.  From your report, I cannot tell if there's a particular
> > place on the screen where problem occurs.  For instance, selecting near
> > the bottom, or close to one side might be relevant.
> 
> I was triple-clicking near the center of the window. But perhaps you
> should let the mouse button pressed longer and move the mouse pointer
> upward/downward.

That would be the "same" as the case I was talking about.  xterm apparently
allows one to multi-click and extend selection at the same "time", since it
is handling events.  (I don't know if it would be hard to change that).

But it does not correspond to the symptom that you were describing, i.e.,
selecting from the current point to the bottom of the screen.  Extending
the selection should make the selection (triple-clicking, etc), apply
to no lines past the cursor click.

Given that, I've been looking for some case where there's an error in
the indices used to point into the screen, e.g., a -1 that's sign-extended,
causing it to use a much larger size than expected.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Michel Dänzer <daenzer@debian.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #85 received at 430121@bugs.debian.org (full text, mbox):

From: Michel Dänzer <daenzer@debian.org>
To: Thomas Dickey <dickey@radix.net>, 430121@bugs.debian.org
Cc: Vincent Lefevre <vincent@vinc17.org>
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 12:24:33 +0200
On Wed, 2007-06-27 at 06:06 -0400, Thomas Dickey wrote:
> 
> Given that, I've been looking for some case where there's an error in
> the indices used to point into the screen, e.g., a -1 that's sign-extended,
> causing it to use a much larger size than expected.

Let me point out that char is unsigned by default on powerpc. Could
there be code in xterm that assumes otherwise?


-- 
Earthling Michel Dänzer           |          http://tungstengraphics.com
Libre software enthusiast         |          Debian, X and DRI developer



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #90 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Michel Dänzer <daenzer@debian.org>
Cc: 430121@bugs.debian.org, Vincent Lefevre <vincent@vinc17.org>
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 06:34:19 -0400
[Message part 1 (text/plain, inline)]
On Wed, Jun 27, 2007 at 12:24:33PM +0200, Michel Dänzer wrote:
> On Wed, 2007-06-27 at 06:06 -0400, Thomas Dickey wrote:
> > 
> > Given that, I've been looking for some case where there's an error in
> > the indices used to point into the screen, e.g., a -1 that's sign-extended,
> > causing it to use a much larger size than expected.
> 
> Let me point out that char is unsigned by default on powerpc. Could
> there be code in xterm that assumes otherwise?

There "could" be, though it's something that I check for via compiler
warnings, etc.  But the relevant types to be concerned about are
unsigned short versus int - those behave the same way everywhere.

Compiler warnings don't tell everything of course, but since I've
not been able to reproduce the problem, I'm only using the description.
Sniffing around with valgrind doesn't show me any problems either.
(It would be nice if X libraries didn't leak like a sieve ;-)

If I had a case like that which I could reproduce, but not understand,
I'd configure xterm using --enable-trace and study the corresponding
Trace-parent.out file (which would tell the line- and columns for the
selection, as well as the actual text selected).

It's harder to diagnose a problem where the pasting isn't happening
because the receiving xterm is in a bad state.  But for the moment I'm
hoping that there's "only" a problem with selection.

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #95 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Michel Dänzer <daenzer@debian.org>
Cc: Thomas Dickey <dickey@radix.net>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 13:15:45 +0200
On 2007-06-27 12:24:33 +0200, Michel Dänzer wrote:
> Let me point out that char is unsigned by default on powerpc. Could
> there be code in xterm that assumes otherwise?

I can reproduce the bug on both x86 and powerpc.

BTW, is there a way to record X events and replay them?

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #100 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: Michel Dänzer <daenzer@debian.org>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 07:34:45 -0400
[Message part 1 (text/plain, inline)]
On Wed, Jun 27, 2007 at 01:15:45PM +0200, Vincent Lefevre wrote:
> On 2007-06-27 12:24:33 +0200, Michel Dänzer wrote:
> > Let me point out that char is unsigned by default on powerpc. Could
> > there be code in xterm that assumes otherwise?
> 
> I can reproduce the bug on both x86 and powerpc.
> 
> BTW, is there a way to record X events and replay them?

Supposedly (there's an XTest extension).  But I haven't seen anyone
responding on xorg to the occasional request for information regarding
this.  Most of the references to it are very old.  Here's a museum:

http://www.freedesktop.org/wiki/Software/XTesting

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #105 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: Michel Dänzer <daenzer@debian.org>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 23:08:15 +0200
On 2007-06-27 07:34:45 -0400, Thomas Dickey wrote:
> Supposedly (there's an XTest extension).  But I haven't seen anyone
> responding on xorg to the occasional request for information regarding
> this.  Most of the references to it are very old.  Here's a museum:
> 
> http://www.freedesktop.org/wiki/Software/XTesting

I haven't found. The closest would be xnee (I've used "xnee -rec -fc
--all-events -o rec -l -1"), but it just records keyboard and mouse
events, and doesn't record what is displayed.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #110 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: Michel Dänzer <daenzer@debian.org>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 23:15:31 +0200
On 2007-06-27 23:08:15 +0200, Vincent Lefevre wrote:
> I haven't found. The closest would be xnee (I've used "xnee -rec -fc
> --all-events -o rec -l -1"), but it just records keyboard and mouse
> events, and doesn't record what is displayed.

But perhaps this is the solution:

  http://www.unixuser.org/~euske/vnc2swf/

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Vincent Lefevre <vincent@vinc17.org>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #115 received at 430121@bugs.debian.org (full text, mbox):

From: Vincent Lefevre <vincent@vinc17.org>
To: Thomas Dickey <dickey@radix.net>
Cc: Michel Dänzer <daenzer@debian.org>, 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Thu, 28 Jun 2007 00:31:55 +0200
On 2007-06-27 23:15:31 +0200, Vincent Lefevre wrote:
>   http://www.unixuser.org/~euske/vnc2swf/

I've used that to generate the movie you can see at:

  http://www.vinc17.org/download/debbug430121.html

It lasts about 34 seconds.

-- 
Vincent Lefèvre <vincent@vinc17.org> - Web: <http://www.vinc17.org/>
100% accessible validated (X)HTML - Blog: <http://www.vinc17.org/blog/>
Work: CR INRIA - computer arithmetic / Arenaire project (LIP, ENS-Lyon)



Information forwarded to debian-bugs-dist@lists.debian.org, Debian X Strike Force <debian-x@lists.debian.org>:
Bug#430121; Package xterm. Full text and rfc822 format available.

Acknowledgement sent to Thomas Dickey <dickey@radix.net>:
Extra info received and forwarded to list. Copy sent to Debian X Strike Force <debian-x@lists.debian.org>. Full text and rfc822 format available.

Message #120 received at 430121@bugs.debian.org (full text, mbox):

From: Thomas Dickey <dickey@radix.net>
To: Vincent Lefevre <vincent@vinc17.org>
Cc: 430121@bugs.debian.org
Subject: Re: Bug#430121: xterm: EOL characters missing from selection (affects triple-click)
Date: Wed, 27 Jun 2007 20:32:37 -0400
[Message part 1 (text/plain, inline)]
On Thu, Jun 28, 2007 at 12:31:55AM +0200, Vincent Lefevre wrote:
> On 2007-06-27 23:15:31 +0200, Vincent Lefevre wrote:
> >   http://www.unixuser.org/~euske/vnc2swf/
> 
> I've used that to generate the movie you can see at:
> 
>   http://www.vinc17.org/download/debbug430121.html

One difference that I noticed is that you used the scrollbar (I was
using shift pageup/pagedown).  That is probably relevant, since using the
scrollbar, I was able to make it select more than two lines.  It
seems that I have to scroll back more than once.

I can reproduce the same effect with xterm #212 and #204 (so I'm
reasonably sure it's not a recent problem).

-- 
Thomas E. Dickey
http://invisible-island.net
ftp://invisible-island.net
[Message part 2 (application/pgp-signature, inline)]

Reply sent to Julien Cristau <jcristau@debian.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Vincent Lefevre <vincent@vinc17.org>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #125 received at 430121-close@bugs.debian.org (full text, mbox):

From: Julien Cristau <jcristau@debian.org>
To: 430121-close@bugs.debian.org
Subject: Bug#430121: fixed in xterm 228-1
Date: Mon, 23 Jul 2007 02:02:03 +0000
Source: xterm
Source-Version: 228-1

We believe that the bug you reported is fixed in the latest version of
xterm, which is due to be installed in the Debian FTP archive:

xterm_228-1.diff.gz
  to pool/main/x/xterm/xterm_228-1.diff.gz
xterm_228-1.dsc
  to pool/main/x/xterm/xterm_228-1.dsc
xterm_228-1_i386.deb
  to pool/main/x/xterm/xterm_228-1_i386.deb
xterm_228.orig.tar.gz
  to pool/main/x/xterm/xterm_228.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 430121@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Julien Cristau <jcristau@debian.org> (supplier of updated xterm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.7
Date: Mon, 23 Jul 2007 03:43:32 +0200
Source: xterm
Binary: xterm
Architecture: source i386
Version: 228-1
Distribution: unstable
Urgency: low
Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Changed-By: Julien Cristau <jcristau@debian.org>
Description: 
 xterm      - X terminal emulator
Closes: 369920 403360 430121
Changes: 
 xterm (228-1) unstable; urgency=low
 .
   [ Julien Cristau ]
   * New upstream release
     + fix missing assignment for UTF-8 parsing in widget initialization
       (closes: #403360).
     + correct index expression used to set line-wrapping flag, making
       selection from scrollback work consistently (closes: #430121).
   * Refresh 901_xterm_manpage.diff.
 .
   [ Brice Goglin ]
   * Fix debian/rules to not be confused by ~/.quiltrc or QUILT_PATCHES,
     closes: #369920.
Files: 
 f67ca444d3555233b1215f3802d1d448 825 x11 optional xterm_228-1.dsc
 35e0b1bfc9351519b3705d102cf24241 841482 x11 optional xterm_228.orig.tar.gz
 03b70a6e8e3502662b424f32a2118411 61896 x11 optional xterm_228-1.diff.gz
 b50d47b20ce665cf093959c408800f11 454298 x11 optional xterm_228-1_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.6 (GNU/Linux)

iD8DBQFGpAnpmEvTgKxfcAwRArmrAKDcrKsdw3cwhakRFagblUqKceqccwCgnnAy
5bQ997pNlS9cJLclL+4+c9E=
=HP3b
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 31 Aug 2007 07:26:56 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 04:13:34 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.